from browser import websocket


########################################################################
class WebSocket:
    """"""

    #----------------------------------------------------------------------
    def __init__(cls, ip):
        """"""
        if not websocket.supported:
            print("WebSocket is not supported by your browser")
            return
        # open a web socket
        #cls.ws = websocket.WebSocket("wss://192.168.1.20:8888")
        cls.ws = websocket.WebSocket(ip)
        # bind functions to web socket events
        cls.ws.bind('open', cls.on_open)
        cls.ws.bind('error', cls.on_error)
        cls.ws.bind('message', cls.on_message)
        cls.ws.bind('close', cls.on_close)

        print("Connected to {}".format(ip))


        port_ip = ip.replace('wss://', '').replace('ws://', '').replace('/ws', '')

        print(port_ip)


        #cls.ip = port_ip[:port_ip.find(":")]
        #cls.port =  port_ip[port_ip.find(":")+1:]
        cls.ip = port_ip
        cls.protocol = 'wss' if 'wss' in ip else 'ws'



    #----------------------------------------------------------------------
    def on_open(cls, evt):
        """"""
        print("Websocket engage.")


    #----------------------------------------------------------------------
    def on_error(cls, evt):
        """"""
        print("Error.")


    #----------------------------------------------------------------------
    def on_message(cls, evt):
        """"""
        print("Message received: {}".format(evt.data))


    #----------------------------------------------------------------------
    def on_close(cls, evt):
        """"""
        print("Websocket closed.")


    #----------------------------------------------------------------------
    def send(cls, data):
        """"""
        if data:
            cls.ws.send(data)


    #----------------------------------------------------------------------
    def close_connection(cls, ev):
        """"""
        cls.ws.close()
